using System;
using System.Security.Permissions;
using System.Windows.Forms;


namespace DAMac {
    public partial class DAMacForm : Form {
        private DAMacros daMacros;

        public DAMacForm() {
            InitializeComponent();

            if(!System.IO.File.Exists("DAData.xml")) { MessageBox.Show("DAData.xml file not found: Download the file from www.da-wizard.com."); Environment.Exit(0); }

            sysTrayIcon.Icon = MyResources.Resources.DA_MacSysNormal;
            daMacros = new DAMacros(this.Handle, sysTrayIcon, MyResources.Resources.DA_MacSysNormal, MyResources.Resources.DA_MacSysRun);
            daMacros.MainF = this;
            this.Text = "AoEnchanter v" + Application.ProductVersion;

            comboBox1.SelectedIndex = 0;
            loadSettings();
        }

        private void exitToolStripMenuItem_Click(object sender, EventArgs e) {
            saveSettings();
            Application.Exit();
        }
        [SecurityPermission(SecurityAction.LinkDemand, Flags = SecurityPermissionFlag.UnmanagedCode)]
        protected override void WndProc(ref Message m) {
            if(m.Msg == 0x0312 && daMacros.StartHK((ushort)m.WParam)) { } //WM_HOTKEY = 0x0312;
            else base.WndProc(ref m);
        }



        private void setSpellsToolStripMenuItem_Click(object sender, EventArgs e) {
            this.WindowState = System.Windows.Forms.FormWindowState.Normal;
            this.Show();
            this.Focus();
        }

        private void Close_Click(object sender, EventArgs e) {
            //this.WindowState = System.Windows.Forms.FormWindowState.Minimized;
            this.Hide();
        }

        public void saveSettings() {
            System.IO.StreamWriter SaveFile;
            try { SaveFile = System.IO.File.CreateText("AOEnchanterSet.ini"); } catch(Exception e2) { MessageBox.Show("Couldn't Create Save File" + e2.Message); return; }

            if(checkBox_puin.Checked) SaveFile.WriteLine("t");
            else SaveFile.WriteLine("f");
            if(checkBox_dall.Checked) SaveFile.WriteLine("t");
            else SaveFile.WriteLine("f");
            if(checkBox_suain.Checked) SaveFile.WriteLine("t");
            else SaveFile.WriteLine("f");
            if(checkBox_ard.Checked) SaveFile.WriteLine("t");
            else SaveFile.WriteLine("f");
            if(checkBox_mor.Checked) SaveFile.WriteLine("t");
            else SaveFile.WriteLine("f");
            if(checkBox_cradh.Checked) SaveFile.WriteLine("t");
            else SaveFile.WriteLine("f");
            if(checkBox_beag.Checked) SaveFile.WriteLine("t");
            else SaveFile.WriteLine("f");
            if(checkBox_tooltip.Checked) SaveFile.WriteLine("t");
            else SaveFile.WriteLine("f");
            if(checkBox_beagcradh.Checked) SaveFile.WriteLine("t");
            else SaveFile.WriteLine("f");

            if(checkBox_instantaopuin.Checked) SaveFile.WriteLine("t");
            else SaveFile.WriteLine("f");
            if(checkBox_instantaodall.Checked) SaveFile.WriteLine("t");
            else SaveFile.WriteLine("f");
            if(checkBox_instantaosuain.Checked) SaveFile.WriteLine("t");
            else SaveFile.WriteLine("f");
            if(checkBox_instantaoard.Checked) SaveFile.WriteLine("t");
            else SaveFile.WriteLine("f");
            if(checkBox_instantaomor.Checked) SaveFile.WriteLine("t");
            else SaveFile.WriteLine("f");
            if(checkBox_instantaocradh.Checked) SaveFile.WriteLine("t");
            else SaveFile.WriteLine("f");
            if(checkBox_instantaobeag.Checked) SaveFile.WriteLine("t");
            else SaveFile.WriteLine("f");
            if(checkBox_instantbeagcradh.Checked) SaveFile.WriteLine("t");
            else SaveFile.WriteLine("f");

            SaveFile.WriteLine(comboBox1.SelectedIndex);
            SaveFile.Close();
        }

        public void loadSettings() {
            System.IO.StreamReader SaveFile;
            if(!System.IO.File.Exists("AOEnchanterSet.ini")) return;
            try { SaveFile = System.IO.File.OpenText("AOEnchanterSet.ini"); } catch(Exception e2) { MessageBox.Show("Couldn't Load File" + e2.Message); return; }

            if(SaveFile.ReadLine() == "t") checkBox_puin.Checked = true;
            else checkBox_puin.Checked = false;
            if(SaveFile.ReadLine() == "t") checkBox_dall.Checked = true;
            else checkBox_dall.Checked = false;
            if(SaveFile.ReadLine() == "t") checkBox_suain.Checked = true;
            else checkBox_suain.Checked = false;
            if(SaveFile.ReadLine() == "t") checkBox_ard.Checked = true;
            else checkBox_ard.Checked = false;
            if(SaveFile.ReadLine() == "t") checkBox_mor.Checked = true;
            else checkBox_mor.Checked = false;
            if(SaveFile.ReadLine() == "t") checkBox_cradh.Checked = true;
            else checkBox_cradh.Checked = false;
            if(SaveFile.ReadLine() == "t") checkBox_beag.Checked = true;
            else checkBox_beag.Checked = false;
            if(SaveFile.ReadLine() == "t") checkBox_tooltip.Checked = true;
            else checkBox_tooltip.Checked = false;
            if(SaveFile.ReadLine() == "t") checkBox_beagcradh.Checked = true;
            else checkBox_beagcradh.Checked = false;

            if(SaveFile.ReadLine() == "t") checkBox_instantaopuin.Checked = true;
            else checkBox_instantaopuin.Checked = false;
            if(SaveFile.ReadLine() == "t") checkBox_instantaodall.Checked = true;
            else checkBox_instantaodall.Checked = false;
            if(SaveFile.ReadLine() == "t") checkBox_instantaosuain.Checked = true;
            else checkBox_instantaosuain.Checked = false;
            if(SaveFile.ReadLine() == "t") checkBox_instantaoard.Checked = true;
            else checkBox_instantaoard.Checked = false;
            if(SaveFile.ReadLine() == "t") checkBox_instantaomor.Checked = true;
            else checkBox_instantaomor.Checked = false;
            if(SaveFile.ReadLine() == "t") checkBox_instantaocradh.Checked = true;
            else checkBox_instantaocradh.Checked = false;
            if(SaveFile.ReadLine() == "t") checkBox_instantaobeag.Checked = true;
            else checkBox_instantaobeag.Checked = false;
            if(SaveFile.ReadLine() == "t") checkBox_instantbeagcradh.Checked = true;
            else checkBox_instantbeagcradh.Checked = false;

            int temp;
            if(int.TryParse(SaveFile.ReadLine(), out temp))
                if(temp != 0) comboBox1.SelectedIndex = temp;
            SaveFile.Close();
        }

        private void resetFunc_Click(object sender, EventArgs e) {
            checkBox_puin.Checked = true;
            checkBox_dall.Checked = true;
            checkBox_suain.Checked = true;
            checkBox_ard.Checked = true;
            checkBox_mor.Checked = true;
            checkBox_cradh.Checked = true;
            checkBox_beag.Checked = false;
            checkBox_tooltip.Checked = true;
            checkBox_beagcradh.Checked = true;

            checkBox_instantaopuin.Checked = false;
            checkBox_instantaodall.Checked = false;
            checkBox_instantaosuain.Checked = false;
            checkBox_instantaoard.Checked = false;
            checkBox_instantaomor.Checked = false;
            checkBox_instantaocradh.Checked = false;
            checkBox_instantaobeag.Checked = false;
            checkBox_instantbeagcradh.Checked = true;

            comboBox1.SelectedIndex = 0;
        }

        private void macroKey_Changed(object sender, EventArgs e) { daMacros.changeMacro(comboBox1.SelectedIndex); }
        private void checkBox7_Click(object sender, EventArgs e) { checkBox_beagcradh.Checked = false; }
        private void checkBox9_Click(object sender, EventArgs e) { checkBox_beag.Checked = false; }
    }
}